From 37bd81d6edc500b8904d3463d0044c5b402e5042 Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Feb 01 2017 17:30:36 +0000
Subject: [PATCH 684/1001] Use the registry to discover widget routes


---

diff --git a/hubs/tests/test_widget_routes.py b/hubs/tests/test_widget_routes.py
new file mode 100644
index 0000000..be03bd8
--- /dev/null
+++ b/hubs/tests/test_widget_routes.py
@@ -0,0 +1,67 @@
+from __future__ import unicode_literals
+
+import hubs.widgets
+
+from mock import Mock
+from hubs.models import Hub, Widget
+from hubs.tests import APPTest
+
+class WidgetRoutesTest(APPTest):
+
+    def setUp(self):
+        super(WidgetRoutesTest, self).setUp()
+        # Backup the URL map
+        self._old_url_map = (
+            self.app.application.url_map._rules.copy(),
+            self.app.application.url_map._rules_by_endpoint.copy()
+            )
+
+    def tearDown(self):
+        for module in hubs.widgets.registry.values():
+            if hasattr(module, 'ROUTES'):
+                delattr(module, 'ROUTES')
+        # Restore the URL map
+        self.app.application.url_map._rules = self._old_url_map[0]
+        self.app.application.url_map._rules_by_endpoint = self._old_url_map[1]
+        super(WidgetRoutesTest, self).tearDown()
+
+    def test_routes_variable(self):
+        mock_view = Mock(return_value='')
+        hubs.widgets.contact.mock_view = mock_view
+        hubs.widgets.contact.ROUTES = [{
+            'rule': 'dummy-url',
+            'endpoint': 'dummy-endpoint',
+            'view_func_name': 'mock_view',
+        }]
+        hubs.views._load_widget_views()
+        added_rules = list(
+            self.app.application.url_map.iter_rules(
+                endpoint='contact_dummy-endpoint')
+            )
+        self.assertEqual(len(added_rules), 1)
+        self.assertEqual(
+            added_rules[0].rule,
+            '/<hub>/<int:idx>/widget/dummy-url'
+            )
+        widget = self.session.query(Widget).filter_by(
+            plugin="contact").first()
+        self.app.get('/%s/%s/widget/dummy-url'
+                     % (widget.hub.name, widget.idx))
+        self.assertTrue(mock_view.called)
+        call = mock_view.call_args_list[0]
+        # Check arguments: session and widget
+        self.assertEqual(call[0][0].__class__, self.session.__class__)
+        self.assertEqual(call[0][1], widget)
+
+    def test_decorator(self):
+        mock_view = Mock(return_value='')
+        mock_view.__name__ = 'mock_view'
+        mock_view.__module__ = 'hubs.widgets.feed'
+        hubs.widgets.feed.mock_view = hubs.widgets.base.widget_route(
+            rule='dummy-url', endpoint='dummy-endpoint')(mock_view)
+        self.assertEqual(
+            hubs.widgets.feed.ROUTES,
+            [{'view_func_name': 'mock_view',
+              'endpoint': 'dummy-endpoint',
+              'rule': 'dummy-url'}]
+            )
diff --git a/hubs/views/__init__.py b/hubs/views/__init__.py
index f39cc0c..f388470 100644
--- a/hubs/views/__init__.py
+++ b/hubs/views/__init__.py
@@ -14,7 +14,7 @@ from .plus_plus import *
 import flask
 import functools
 import hubs.models
-from sqlalchemy.exc import OperationalError
+import hubs.widgets
 from sqlalchemy.orm.exc import NoResultFound
 from hubs.app import app, session
 from .utils import get_widget
@@ -31,23 +31,21 @@ def _widget_view_decorator(func):
     def inner(*args, **kwargs):
         hubname = kwargs.pop("hub")
         widgetidx = kwargs.pop("idx")
-        widget = get_widget(hubname, widgetidx, session=session)
+        widget = get_widget(hubname, widgetidx)
         return func(session, widget, *args, **kwargs)
     return inner
 
 def _load_widget_views():
-    for widget in session.query(hubs.models.Widget):
-        for params in getattr(widget.module, 'ROUTES', []):
+    for name, module in hubs.widgets.registry.items():
+        #print(module, hasattr(module, 'ROUTES'))
+        for params in getattr(module, 'ROUTES', []):
             params["rule"] = "/<hub>/<int:idx>/widget/" \
                              + params["rule"].lstrip("/")
             if not params.get("endpoint"):
                 params["endpoint"] = params["view_func_name"]
-            params["endpoint"] = "%s_%s" % (widget.plugin, params["endpoint"])
+            params["endpoint"] = "%s_%s" % (name, params["endpoint"])
             params["view_func"] = _widget_view_decorator(
-                getattr(widget.module, params.pop("view_func_name")))
+                getattr(module, params.pop("view_func_name")))
             app.add_url_rule(**params)
 
-try:
-    _load_widget_views()
-except OperationalError:
-    pass  # Maybe the DB is not yet initialized (tests).
+_load_widget_views()

